Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 382285)
+++ channels/chan_skinny.c	(working copy)
@@ -5451,10 +5451,10 @@
 			ast_channel_amaflags_set(tmp, l->amaflags);
 
 		ast_module_ref(ast_module_info->self);
-		ast_channel_callgroup_set(tmp, l->callgroup);
+		ast_channel_callgroup_set(tmp, (l->callgroup ? l->callgroup : l->pickupgroup));
 		ast_channel_pickupgroup_set(tmp, l->pickupgroup);
 
-		ast_channel_named_callgroups_set(tmp, l->named_callgroups);
+		ast_channel_named_callgroups_set(tmp, (l->named_callgroups ? l->named_callgroups : l->named_pickupgroups));
 		ast_channel_named_pickupgroups_set(tmp, l->named_pickupgroups);
 
 		/* XXX Need to figure out how to handle CFwdNoAnswer */
@@ -7257,6 +7257,11 @@
 	case SOFTKEY_GPICKUP:
 		SKINNY_DEBUG(DEBUG_PACKET, 3, "Received SOFTKEY_GPICKUP from %s, inst %d, callref %d\n",
 			d->name, instance, callreference);
+		if (!(l->pickupgroup || l->named_pickupgroups)) {
+			SKINNY_DEBUG(DEBUG_GENERAL, 3, "SOFTKEY_GPICKUP disabled because no pickupgroup specified for line %s\n",
+				l->name);
+			break;
+		}
 		if (!sub || !sub->owner) {
 			c = skinny_new(l, NULL, AST_STATE_DOWN, NULL, SKINNY_INCOMING);
 		} else {
